package net.sf.sido.editor;

import org.apache.commons.lang.StringUtils;
import org.joda.time.Period;
import org.joda.time.format.ISOPeriodFormat;

public class PeriodEditor implements DataEditor<Period> {

	@Override
	public String toString(Period value) {
		if (value == null) {
			return null;
		} else {
			return ISOPeriodFormat.standard().print(value);
		}
	}

	@Override
	public Period valueOf(String value) {
		if (StringUtils.isBlank(value)) {
			return null;
		} else {
			return ISOPeriodFormat.standard().parsePeriod(value);
		}
	}

}
