package net.sf.sido.factory.support;

import com.google.common.base.Predicate;
import net.sf.sido.DataFactory;
import net.sf.sido.DataObject;
import net.sf.sido.DataSchema;
import net.sf.sido.array.Array;

import java.io.IOException;
import java.util.Map;

public class ArraySimplePropertyAssembler extends AbstractPropertyAssembler {

	private final String type;

	public ArraySimplePropertyAssembler(String name, String type) {
		super(name);
		this.type = type;
	}

    @Override
    public <T> void addProperty(DataFactory factory, PropertyAssemblerCallback callback, Map<String, DataSchema> schemas, Map<String, TypeDefinition> typeDefinitions, TypeDefinition definition, DataObject property) throws IOException {
		// Element type
		Class<T> elementType = factory.getSimpleType(type);
		// Nullable
		boolean nullable = isNullable(property);
		// Constraint
		Predicate<Array<T>> constraint = readConstraint(factory, property);
		// Adds the property
		definition.getBuilder().addArrayProperty(name, elementType, nullable, constraint);
	}
}
