package net.sf.sido.support;

import net.sf.sido.DOUndefinedPropertyException;
import net.sf.sido.DataObject;
import net.sf.sido.Property;

public class PropertyDataObjectController extends DataObjectControllerAdapter {

	@Override
	public <T> T onPropertyGet(DataObject o, String name, T value) {
		Property<Object> property = o.getSidoType().getProperty(name);
		if (property == null) {
			throw new DOUndefinedPropertyException(o, name);
		}
		return value;
	}

	@Override
	public <T> T onPropertySetPre(DataObject o, String name, T oldValue, T value) {
		Property<T> property = o.getSidoType().getProperty(name);
		if (property == null) {
			throw new DOUndefinedPropertyException(o, name);
		} else {
			return property.apply(o, value);
		}
	}

}
